<template>
  <div class="container">
    <header class="jumbotron">

      <div>
        <button class="btn btn-success" v-on:click="addBeegarden()">Dodaj pasiekę</button>
      </div>

    </header>

      <div class="col-md-8" v-if="beegardens.length !== 0">

        <div class="card mb-3" v-for="item in beegardens" v-bind:key="item.id">
          <div class="card-body">


            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Nazwa Pasieki:</h6>
              </div>
              <div class="col-sm-9 text-secondary">
                {{ item.beegardenName }}
              </div>
            </div>

            <hr>
            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Lokalizacja Pasieki:</h6>
              </div>
              <div class="col-sm-9 text-secondary">
                {{ item.location }}
              </div>
            </div>
            <hr>

            <button class="btn btn-info mr-1" v-on:click="openSpecificBeegarden(item.id)">Zobacz ule należące do tej pasieki</button>
            <button class="btn btn-warning mr-1" v-on:click="editSpecificBeegarden(item.id)">Edytuj detale tej pasieki</button>
            <button class="btn btn-danger" v-on:click="deleteSpecificBeegarden(item.id)">Usuń tą pasiekę</button>
          </div>
        </div>
      </div>


  </div>
</template>

<script>
import BeegardenService from '../../services/beegarden.service';

export default {
  name: 'BoardBeegarden',
  data() {
    return {
      beegardens: ''
    };
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {
    if (!this.currentUser) {
      this.$router.push('/login');
    } else {
      BeegardenService.getAllBeegardensFromUser(this.currentUser.id).then(
          response => {
            this.beegardens = response.data;
          },
          error => {
            this.beegardens =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }


    // eslint-disable-next-line no-console
    console.log("Y: " + this.beegardens.beegardenIds)


  },
  methods: {
    openSpecificBeegarden(beegardenId) {
      this.$router.push('/boardbeehives?beegardenid=' + beegardenId);
    },

    addBeegarden() {
      this.$router.push('/addbeegarden');
    },

    editSpecificBeegarden(beegardenId) {
      this.$router.push('/editbeegarden?beegardenid=' + beegardenId);
    },

    deleteSpecificBeegarden(beegardenId) {

      if (confirm("Jesteś pewny? Usuniesz wszystkie ule należące do tej pasieki i ich detale.")) {
        BeegardenService.deleteSpecificBeegarden(beegardenId).then(
            response => {
              this.beegardens = response.data;
              alert('Usunięcie pasieki przebiegło pomyślnie')
              this.refreshBeegardenList()
            },
            error => {
              this.beegardens =
                  (error.response && error.response.data && error.response.data.message) ||
                  error.message ||
                  error.toString();
            }
        );
      }
    },

    refreshBeegardenList() {
      BeegardenService.getAllBeegardensFromUser(this.currentUser.id).then(
          response => {
            this.beegardens = response.data;
          },
          error => {
            this.beegardens =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

  }
};
</script>

<style>

.card {
  position: relative;
  display: flex;
  flex-direction: column;
  min-width: 0;
  word-wrap: break-word;
  background-color: #fff;
  background-clip: border-box;
  border: 0 solid rgba(0,0,0,.125);
  border-radius: .25rem;
}

.card-body {
  flex: 1 1 auto;
  min-height: 1px;
  padding: 1rem;
}

.mb-3 {
  margin-bottom: 1rem!important;
}

</style>